/*
	$Id: ArrayStack.c 227 2006-06-01 14:49:21Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

#include <err.h>
#include <stdlib.h>
#include <tf/TestFunnel.h>
#include <Stack.h>

const char tf_description[] = "Test of ArrayStack class.";

#include "../Stack/Stack.c"

void
tf_initialize(void)
{
    initialize();
    s = Stack_create(2);
}

void
tf_finalize(void)
{
    Stack_free(s);
}

TF_METHOD(push3)
{
    int e;

    (void)Stack_push(s, &c1);
    (void)Stack_push(s, &c2);
    e = Stack_push(s, &c3);
    tf_assert(e == STACK_ERROR);
}

TF_METHOD(pop3)
{
    struct StackCell *c;

    (void)Stack_push(s, &c1);
    (void)Stack_push(s, &c2);
    (void)Stack_push(s, &c3);
    c = Stack_pop(s);
    tf_assert(c == &c2 && c->value == 2);
    c = Stack_pop(s);
    tf_assert(c == &c1 && c->value == 1);
    c = Stack_pop(s);
    tf_assert(c == NULL);
}

TF_METHOD(top3)
{
    struct StackCell *c;

    (void)Stack_push(s, &c1);
    (void)Stack_push(s, &c2);
    (void)Stack_push(s, &c3);
    c = Stack_top(s);
    tf_assert(c == &c2 && c->value == 2);
    c = Stack_top(s);
    tf_assert(c == &c2 && c->value == 2);
}

TF_METHOD(getSize3)
{
    (void)Stack_push(s, &c1);
    (void)Stack_push(s, &c2);
    (void)Stack_push(s, &c3);
    tf_assert(Stack_getSize(s) == 2);
}

TF_METHOD(getSize31)
{
    (void)Stack_push(s, &c1);
    (void)Stack_push(s, &c2);
    (void)Stack_push(s, &c3);
    (void)Stack_pop(s);
    tf_assert(Stack_getSize(s) == 1);
}

TF_METHOD(getSize30)
{
    (void)Stack_push(s, &c1);
    (void)Stack_push(s, &c2);
    (void)Stack_push(s, &c3);
    (void)Stack_pop(s);
    (void)Stack_pop(s);
    tf_assert(Stack_getSize(s) == 0);
}
